@ECHO off

rem ******************************************************************************************************************************
rem * Licensed Materials - Property of IBM                                                                                       *
rem * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
rem *                                                                                                                            *
rem *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
rem ******************************************************************************************************************************

IF NOT DEFINED LOCALE (SET LOCALE= )

SET LOCEN=0409
SET LOCIT=0410 
SET LOCJP=0411 
SET LOCKO=0412 
SET LOCPO=0415 
SET LOCCHS=0804
SET LOCCHT=0404

IF NOT DEFINED SQLSERVINST (SET SQLSERVINST= )
IF NOT DEFINED DBNAME      (SET DBNAME= ) 
IF NOT DEFINED NF_SCHEMA   (SET NF_SCHEMA= ) 
IF NOT DEFINED STAR_SCHEMA (SET STAR_SCHEMA= ) 
IF NOT DEFINED REP_USER    (SET REP_USER= ) 
IF NOT DEFINED DATA_HOME   (SET DATA_HOME= ) 
IF NOT DEFINED MSSQL_HOME  (SET MSSQL_HOME= ) 
IF NOT DEFINED JAVA_HOME (SET JAVA_HOME= )



SET EXITCODE=0
SET MESSAGE= xxx

IF NOT EXIST set_env.bat (
                           SET EXITCODE=4597 
                           GOTO done
                                    ) ELSE (                
                       call set_env.bat
                                  )



IF "%JAVA_HOME%" EQU " " (
SET EXITCODE= 4596 
GOTO done)  


SET CURDIR=%CD%

CD /d "%JAVA_HOME%\bin"
IF "%ERRORLEVEL%" EQU "1" (
SET EXITCODE=4596
GOTO done)

IF NOT EXIST java.exe (
SET EXITCODE= 4598
GOTO done   ) 

CD /d %CURDIR%

set path=%JAVA_HOME%\bin;%path%



REG QUERY "HKCU\Control Panel\International" /v Locale>locale.txt

java com.ibm.rational.vega.dw.SearchAndReplace %LOCIT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCIT%
call lang\it\messages.bat) 
java com.ibm.rational.vega.dw.SearchAndReplace %LOCJP% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCJP%
call lang\jp\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCKO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCKO%
call lang\kr\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCPO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCPO%
call lang\pl\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHS% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHS%
call lang\zh_CN\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHT%
call lang\zh_TW\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCEN% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCEN%
call lang\en\messages.bat)

IF "%LOCALE%" EQU " " (
SET LOCALE=%LOCEN%
call lang\en\messages.bat)

IF "%1" EQU "-validate" (GOTO validate)



SET EXITCODE=0
SET MESSAGE=No errors

SET /A SILENT=0
IF "%1" EQU "-silent" (
SET /A SILENT=1) 

SET MSSQL_CMD=
IF "%1" EQU "-debug" (SET MSSQL_CMD= -b -l 60 -e ) ELSE (SET MSSQL_CMD= -b -l 60 )
IF "%2" NEQ "" (IF "%2" EQU "-debug" (SET MSSQL_CMD= -b -l 60 -e ) ELSE (SET MSSQL_CMD= -b -l 60 ))

IF %SILENT% EQU 0 (
ECHO %CRREWECH024%)
IF %SILENT% EQU 0 (
SET /P SQLSERVINST=%CRREWPRMPT023%
)
IF "%SQLSERVINST%" NEQ " " (SET SQLSERVINST=%COMPUTERNAME%\%SQLSERVINST%) ELSE (SET SQLSERVINST=%COMPUTERNAME%)

IF %SILENT% EQU 0 (
SET /P DBNAME=%CRREWPRMPT002%
)
IF "%DBNAME%" EQU " " (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done) 

IF %SILENT% EQU 0 (
SET /P NF_SCHEMA=%CRREWPRMPT005%
)
IF "%NF_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF %SILENT% EQU 0 (
SET /P STAR_SCHEMA=%CRREWPRMPT006%
)
IF "%STAR_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF %SILENT% EQU 0 (
SET /P REP_USER=%CRREWPRMPT007%
)
IF "%REP_USER%" EQU " " (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%

GOTO done)

IF %SILENT% EQU 0 (
SET /P DATA_HOME=%CRREWPRMPT008%
)
IF "%DATA_HOME%" EQU " " (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)

SET DATA_HOME=%DATA_HOME%\%DBNAME%

IF %SILENT% EQU 0 (
SET /P MSSQL_HOME=%CRREWPRMPT024%
)
IF "%MSSQL_HOME%" EQU " " (
SET MESSAGE=%CRREWMSGE079%
SET EXITCODE=%CRREW4579E%
GOTO done)


IF NOT EXIST "%DATA_HOME%"\nul (MKDIR "%DATA_HOME%")



IF NOT EXIST work_spc\nul (MKDIR work_spc) ELSE (
RMDIR /S /Q work_spc
MKDIR work_spc
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

IF NOT EXIST logs\nul (MKDIR logs) ELSE (
RMDIR /S /Q logs
MKDIR logs
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

XCOPY /Y /I /E /Q createDB work_spc\createDB
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)
XCOPY /Y /I /E /Q ddl work_spc\ddl
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)
XCOPY /Y /I /E /Q scripts work_spc\scripts
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)

IF %SILENT% EQU 1 (
SETLOCAL ENABLEDELAYEDEXPANSION
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "SELECT COUNT(*) FROM CONFIG.ETL_INFO"
IF "!ERRORLEVEL!" EQU "0" (
GOTO done)
)

sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" MSSQL_HOME="%MSSQL_HOME%" %MSSQL_CMD% -i "%CD%"\work_spc\createDB\createDB.sql>logs\createDB.log

java com.ibm.rational.vega.dw.SearchAndReplace HResult "%CD%"\logs\createDB.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE013%  
SET EXITCODE=%CRREW4513E%
ECHO %CRREWECH003%
GOTO done)

rem java com.ibm.rational.vega.dw.SearchAndReplace Error "%CD%"\logs\createDB.log>nul
rem IF "%ERRORLEVEL%" EQU "1" ( 
rem SET MESSAGE=%CRREWMSGE013%  
rem SET EXITCODE=%CRREW4513E%
rem ECHO %CRREWECH003%
rem GOTO done)

java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createDB.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE013%  
SET EXITCODE=%CRREW4513E%
ECHO %CRREWECH003%
GOTO done)

sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" NF_SCHEMA="%NF_SCHEMA%" STAR_SCHEMA="%STAR_SCHEMA%" %MSSQL_CMD% -i "%CD%"\work_spc\createDB\createSchema.sql>logs\createSchema.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createSchema.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE013%  
SET EXITCODE=%CRREW4513E%
ECHO %CRREWECH025%
GOTO done)

sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" REP_USER="%REP_USER%" COMPUTER="%COMPUTERNAME%" %MSSQL_CMD% -i "%CD%"\work_spc\createDB\createUsers.sql>logs\createUsers.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createUsers.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE013%  
SET EXITCODE=%CRREW4513E%
ECHO %CRREWECH026%
GOTO done)


sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" %MSSQL_CMD% -i "%CD%"\work_spc\createDB\createFileGroup.sql>logs\createFileGroup.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createFileGroup.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE013%  
SET EXITCODE=%CRREW4513E%
ECHO %CRREWECH027%
GOTO done)

sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" DATA_HOME="%DATA_HOME%" %MSSQL_CMD% -i "%CD%"\work_spc\createDB\createFile.sql>logs\createFile.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createFile.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE013%  
SET EXITCODE=%CRREW4513E%
ECHO %CRREWECH028% 
GOTO done)


sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" %MSSQL_CMD% -i "%CD%"\work_spc\ddl\createSTGCFG.ddl>logs\createSTGCFG.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createSTGCFG.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE016%  
SET EXITCODE=%CRREW4516E%
ECHO %CRREWECH006%
GOTO done)

sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" NF_SCHEMA="%NF_SCHEMA%" %MSSQL_CMD% -i "%CD%"\work_spc\ddl\createNF.ddl>logs\createNF.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createNF.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE017%  
SET EXITCODE=%CRREW4517E%
ECHO %CRREWECH007%
GOTO done)

sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" STAR_SCHEMA="%STAR_SCHEMA%" %MSSQL_CMD% -i "%CD%"\work_spc\ddl\createSTAR.ddl>logs\createSTAR.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createSTAR.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE018%  
SET EXITCODE=%CRREW4518E%
ECHO %CRREWECH008%
GOTO done)
 
sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" STAR_SCHEMA="%STAR_SCHEMA%" NF_SCHEMA="%NF_SCHEMA%" %MSSQL_CMD% -i "%CD%"\work_spc\ddl\createSTARViews.ddl>logs\createSTARViews.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createSTARViews.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE019%  
SET EXITCODE=%CRREW4519E%
ECHO %CRREWECH009%
GOTO done)

sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" STAR_SCHEMA="%STAR_SCHEMA%" REP_USER="%REP_USER%" %MSSQL_CMD% -i "%CD%"\work_spc\scripts\star_grants.sql>logs\star_grants.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\star_grants.log>nul
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE023%  
SET EXITCODE=%CRREW4523E%
ECHO %CRREWECH013%
GOTO done)  
 
sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" STAR_SCHEMA="%STAR_SCHEMA%" CRREWMSGE086="%CRREWMSGE086%" CRREWMSGE087="%CRREWMSGE087%" CRREWMSGE088="%CRREWMSGE088%" CRREWMSGE089="%CRREWMSGE089%" CRREWMSGE090="%CRREWMSGE090%" CRREWMSGE091="%CRREWMSGE091%" CRREWMSGE092="%CRREWMSGE092%" CRREWMSGE093="%CRREWMSGE093%"  %MSSQL_CMD% -i "%CD%"\work_spc\scripts\dtPopulate.sql>logs\dtPopulate.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\dtPopulate.log>nul
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE025%  
SET EXITCODE=%CRREW4525E% 
ECHO %CRREWECH014%
GOTO done) 

IF NOT EXIST implog\nul (MKDIR implog) ELSE (
RMDIR /S /Q implog
MKDIR implog
)

IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

sqlcmd -S %SQLSERVINST% -v RCRNF="%NF_SCHEMA%" RCRDW="%STAR_SCHEMA%" -b -l 60 -h -1 -d %DBNAME% -e -i scripts\sql_trig_dis.sql -o logs\sql_trig_dis.log

sqlcmd -S %SQLSERVINST% -v RCRNF="%NF_SCHEMA%" RCRDW="%STAR_SCHEMA%" -b -l 60 -h -1 -d %DBNAME% -e -i scripts\sql_cnstr_dis.sql -o logs\sql_cnstr_dis.log

call sql_load.bat %SQLSERVINST% %DBNAME% %NF_SCHEMA% %STAR_SCHEMA%>logs\import.log
java com.ibm.rational.vega.dw.SearchAndReplace Error logs\import.log>nul
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE083%  
SET EXITCODE=%CRREW4583E% 
GOTO done) 

sqlcmd -S %SQLSERVINST% -v RCRNF="%NF_SCHEMA%" RCRDW="%STAR_SCHEMA%" -b -l 60 -h -1 -d %DBNAME% -i scripts\sql_cnstr_ena.sql -o logs\sql_cnstr_ena.log

sqlcmd -S %SQLSERVINST% -v RCRNF="%NF_SCHEMA%" RCRDW="%STAR_SCHEMA%" -b -l 60 -h -1 -d %DBNAME% -i scripts\sql_trig_ena.sql -o logs\sql_trig_ena.log

GOTO done

:validate

SET EXITCODE=0
SET MESSAGE=No errors

IF NOT DEFINED DBNAME (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done) 

IF NOT DEFINED NF_SCHEMA   (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF NOT DEFINED STAR_SCHEMA (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF NOT DEFINED REP_USER (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF NOT DEFINED DATA_HOME   (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)

IF NOT DEFINED MSSQL_HOME  (
SET MESSAGE=%CRREWMSGE079%
SET EXITCODE=%CRREW4579E%
GOTO done)

IF "%DBNAME%" EQU " " (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done)

IF "%NF_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF "%STAR_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF "%REP_USER%" EQU " " (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF "%DATA_HOME%" EQU " " (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)

REG QUERY "HKCU\Control Panel\International" /v Locale>nul
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4585E%
SET MESSAGE=%CRREWMSGE085%
GOTO done
)

IF "%MSSQL_HOME%" EQU " " (
SET MESSAGE=%CRREWMSGE079%
SET EXITCODE=%CRREW4579E%
GOTO done)

IF NOT EXIST "%MSSQL_HOME%"\nul (
SET MESSAGE=%CRREWMSGE079%
SET EXITCODE=%CRREW4579E%
GOTO done)



GOTO done

:done 
echo %MESSAGE%:%EXITCODE%
echo %CRREWECH002%
EXIT /B %EXITCODE%